/* WebDialog.c generated by valac 0.36.1, the Vala compiler
 * generated from WebDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2015 Pantheon Developers (https://launchpad.net/switchboard-plug-onlineaccounts)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gsignond/gsignond.h>
#include <webkit2/webkit2.h>
#include <glib/gi18n-lib.h>
#include <granite.h>


#define ONLINE_ACCOUNTS_TYPE_DIALOG (online_accounts_dialog_get_type ())
#define ONLINE_ACCOUNTS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog))
#define ONLINE_ACCOUNTS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialogClass))
#define ONLINE_ACCOUNTS_IS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG))
#define ONLINE_ACCOUNTS_IS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_DIALOG))
#define ONLINE_ACCOUNTS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialogClass))

typedef struct _OnlineAccountsDialog OnlineAccountsDialog;
typedef struct _OnlineAccountsDialogClass OnlineAccountsDialogClass;
typedef struct _OnlineAccountsDialogPrivate OnlineAccountsDialogPrivate;

#define ONLINE_ACCOUNTS_TYPE_WEB_DIALOG (online_accounts_web_dialog_get_type ())
#define ONLINE_ACCOUNTS_WEB_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ONLINE_ACCOUNTS_TYPE_WEB_DIALOG, OnlineAccountsWebDialog))
#define ONLINE_ACCOUNTS_WEB_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ONLINE_ACCOUNTS_TYPE_WEB_DIALOG, OnlineAccountsWebDialogClass))
#define ONLINE_ACCOUNTS_IS_WEB_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ONLINE_ACCOUNTS_TYPE_WEB_DIALOG))
#define ONLINE_ACCOUNTS_IS_WEB_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ONLINE_ACCOUNTS_TYPE_WEB_DIALOG))
#define ONLINE_ACCOUNTS_WEB_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ONLINE_ACCOUNTS_TYPE_WEB_DIALOG, OnlineAccountsWebDialogClass))

typedef struct _OnlineAccountsWebDialog OnlineAccountsWebDialog;
typedef struct _OnlineAccountsWebDialogClass OnlineAccountsWebDialogClass;
typedef struct _OnlineAccountsWebDialogPrivate OnlineAccountsWebDialogPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _OnlineAccountsDialog {
	GtkGrid parent_instance;
	OnlineAccountsDialogPrivate * priv;
	GHashTable* parameters;
	gchar* request_id;
	GSignondSignonuiError error_code;
};

struct _OnlineAccountsDialogClass {
	GtkGridClass parent_class;
	GHashTable* (*get_reply) (OnlineAccountsDialog* self);
	gboolean (*set_parameters) (OnlineAccountsDialog* self, GHashTable* params);
	gboolean (*refresh_captcha) (OnlineAccountsDialog* self, const gchar* uri);
};

struct _OnlineAccountsWebDialog {
	OnlineAccountsDialog parent_instance;
	OnlineAccountsWebDialogPrivate * priv;
};

struct _OnlineAccountsWebDialogClass {
	OnlineAccountsDialogClass parent_class;
};

struct _OnlineAccountsWebDialogPrivate {
	WebKitWebView* webview;
	gchar* oauth_open_url;
	gchar* oauth_final_url;
	gchar* oauth_response;
	GtkLabel* info_label;
	GtkSpinner* spinner;
};


static gpointer online_accounts_web_dialog_parent_class = NULL;

GType online_accounts_dialog_get_type (void) G_GNUC_CONST;
GType online_accounts_web_dialog_get_type (void) G_GNUC_CONST;
#define ONLINE_ACCOUNTS_WEB_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), ONLINE_ACCOUNTS_TYPE_WEB_DIALOG, OnlineAccountsWebDialogPrivate))
enum  {
	ONLINE_ACCOUNTS_WEB_DIALOG_DUMMY_PROPERTY
};
OnlineAccountsWebDialog* online_accounts_web_dialog_new (GHashTable* params);
OnlineAccountsWebDialog* online_accounts_web_dialog_construct (GType object_type, GHashTable* params);
OnlineAccountsDialog* online_accounts_dialog_construct (GType object_type, GHashTable* parameter);
static void __lambda20_ (OnlineAccountsWebDialog* self);
static void ___lambda20__gtk_info_bar_response (GtkInfoBar* _sender, gint response_id, gpointer self);
gboolean online_accounts_dialog_set_parameters (OnlineAccountsDialog* self, GHashTable* params);
static gboolean online_accounts_web_dialog_real_set_parameters (OnlineAccountsDialog* base, GHashTable* params);
static void online_accounts_web_dialog_on_webview_load (OnlineAccountsWebDialog* self, WebKitLoadEvent load_event);
static void _online_accounts_web_dialog_on_webview_load_webkit_web_view_load_changed (WebKitWebView* _sender, WebKitLoadEvent load_event, gpointer self);
static gboolean online_accounts_web_dialog_on_load_uri_failed (OnlineAccountsWebDialog* self, WebKitLoadEvent load_event, const gchar* failing_uri, void* _error);
static gboolean _online_accounts_web_dialog_on_load_uri_failed_webkit_web_view_load_failed (WebKitWebView* _sender, WebKitLoadEvent load_event, const gchar* failing_uri, GError* _error_, gpointer self);
static gboolean online_accounts_web_dialog_validate_params (OnlineAccountsWebDialog* self, GHashTable* params);
static gboolean online_accounts_web_dialog_is_valid_url (OnlineAccountsWebDialog* self, const gchar* uri);
#define ONLINE_ACCOUNTS_KEY_OPEN_URL "OpenUrl"
#define ONLINE_ACCOUNTS_KEY_FINAL_URL "FinalUrl"
static GHashTable* online_accounts_web_dialog_real_get_reply (OnlineAccountsDialog* base);
GHashTable* online_accounts_dialog_get_reply (OnlineAccountsDialog* self);
#define ONLINE_ACCOUNTS_KEY_URL_RESPONSE "UrlResponse"
static gboolean online_accounts_web_dialog_real_refresh_captcha (OnlineAccountsDialog* base, const gchar* uri);
static void online_accounts_web_dialog_finalize (GObject * obj);
static gint _vala_array_length (gpointer array);


static gpointer _g_object_ref0 (gpointer self) {
#line 35 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 132 "WebDialog.c"
}


static void __lambda20_ (OnlineAccountsWebDialog* self) {
#line 46 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	((OnlineAccountsDialog*) self)->error_code = SIGNONUI_ERROR_CANCELED;
#line 47 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_signal_emit_by_name ((OnlineAccountsDialog*) self, "finished");
#line 48 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 143 "WebDialog.c"
}


static void ___lambda20__gtk_info_bar_response (GtkInfoBar* _sender, gint response_id, gpointer self) {
#line 45 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	__lambda20_ ((OnlineAccountsWebDialog*) self);
#line 150 "WebDialog.c"
}


OnlineAccountsWebDialog* online_accounts_web_dialog_construct (GType object_type, GHashTable* params) {
	OnlineAccountsWebDialog * self = NULL;
	GHashTable* _tmp0_;
	GtkInfoBar* infobar;
	GtkInfoBar* _tmp1_;
	GtkContainer* container;
	GtkContainer* _tmp2_;
	GtkContainer* _tmp3_;
	GtkGrid* container_grid;
	GtkGrid* _tmp4_;
	GtkLabel* _tmp5_;
	GtkSpinner* _tmp6_;
	GtkSpinner* _tmp7_;
	GtkSpinner* _tmp8_;
	GtkLabel* _tmp9_;
	WebKitWebContext* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	WebKitWebView* _tmp13_;
	WebKitWebView* _tmp14_;
	GtkEventBox* event_box;
	GtkEventBox* _tmp15_;
	WebKitWebView* _tmp16_;
	GtkStyleContext* _tmp17_;
	GHashTable* _tmp18_;
#line 31 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 32 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp0_ = params;
#line 32 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	self = (OnlineAccountsWebDialog*) online_accounts_dialog_construct (object_type, _tmp0_);
#line 34 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp1_ = (GtkInfoBar*) gtk_info_bar_new_with_buttons (_ ("Cancel"), 0, NULL);
#line 34 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_object_ref_sink (_tmp1_);
#line 34 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	infobar = _tmp1_;
#line 35 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp2_ = gtk_info_bar_get_content_area (infobar);
#line 35 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_container_get_type ()) ? ((GtkContainer*) _tmp2_) : NULL);
#line 35 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	container = _tmp3_;
#line 36 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp4_ = (GtkGrid*) gtk_grid_new ();
#line 36 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_object_ref_sink (_tmp4_);
#line 36 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	container_grid = _tmp4_;
#line 37 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	gtk_grid_set_column_spacing (container_grid, 12);
#line 38 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_ ("Loading…"));
#line 38 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_object_ref_sink (_tmp5_);
#line 38 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_object_unref0 (self->priv->info_label);
#line 38 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	self->priv->info_label = _tmp5_;
#line 39 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	gtk_widget_set_valign ((GtkWidget*) container_grid, GTK_ALIGN_CENTER);
#line 40 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp6_ = (GtkSpinner*) gtk_spinner_new ();
#line 40 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_object_ref_sink (_tmp6_);
#line 40 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_object_unref0 (self->priv->spinner);
#line 40 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	self->priv->spinner = _tmp6_;
#line 41 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp7_ = self->priv->spinner;
#line 41 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	gtk_spinner_start (_tmp7_);
#line 42 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp8_ = self->priv->spinner;
#line 42 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	gtk_grid_attach (container_grid, (GtkWidget*) _tmp8_, 0, 0, 1, 1);
#line 43 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp9_ = self->priv->info_label;
#line 43 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	gtk_grid_attach (container_grid, (GtkWidget*) _tmp9_, 1, 0, 1, 1);
#line 44 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	gtk_container_add (container, (GtkWidget*) container_grid);
#line 45 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_signal_connect_object (infobar, "response", (GCallback) ___lambda20__gtk_info_bar_response, self, 0);
#line 51 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp10_ = webkit_web_context_get_default ();
#line 51 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp12_ = _tmp11_ = g_get_language_names ();
#line 51 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	webkit_web_context_set_preferred_languages (_tmp10_, _tmp12_);
#line 52 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp13_ = (WebKitWebView*) webkit_web_view_new ();
#line 52 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_object_ref_sink (_tmp13_);
#line 52 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_object_unref0 (self->priv->webview);
#line 52 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	self->priv->webview = _tmp13_;
#line 53 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp14_ = self->priv->webview;
#line 53 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_object_set ((GtkWidget*) _tmp14_, "expand", TRUE, NULL);
#line 54 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp15_ = (GtkEventBox*) gtk_event_box_new ();
#line 54 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_object_ref_sink (_tmp15_);
#line 54 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	event_box = _tmp15_;
#line 55 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp16_ = self->priv->webview;
#line 55 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	gtk_container_add ((GtkContainer*) event_box, (GtkWidget*) _tmp16_);
#line 56 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) event_box);
#line 56 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	gtk_style_context_add_class (_tmp17_, GRANITE_STYLE_CLASS_CONTENT_VIEW);
#line 57 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_object_set ((GtkWidget*) event_box, "expand", TRUE, NULL);
#line 58 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) infobar, 0, 0, 1, 1);
#line 59 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) event_box, 0, 1, 1, 1);
#line 60 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 61 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp18_ = params;
#line 61 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	online_accounts_dialog_set_parameters ((OnlineAccountsDialog*) self, _tmp18_);
#line 31 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_object_unref0 (event_box);
#line 31 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_object_unref0 (container_grid);
#line 31 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_object_unref0 (container);
#line 31 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_object_unref0 (infobar);
#line 31 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	return self;
#line 293 "WebDialog.c"
}


OnlineAccountsWebDialog* online_accounts_web_dialog_new (GHashTable* params) {
#line 31 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	return online_accounts_web_dialog_construct (ONLINE_ACCOUNTS_TYPE_WEB_DIALOG, params);
#line 300 "WebDialog.c"
}


static void _online_accounts_web_dialog_on_webview_load_webkit_web_view_load_changed (WebKitWebView* _sender, WebKitLoadEvent load_event, gpointer self) {
#line 69 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	online_accounts_web_dialog_on_webview_load ((OnlineAccountsWebDialog*) self, load_event);
#line 307 "WebDialog.c"
}


static gboolean _online_accounts_web_dialog_on_load_uri_failed_webkit_web_view_load_failed (WebKitWebView* _sender, WebKitLoadEvent load_event, const gchar* failing_uri, GError* _error_, gpointer self) {
	gboolean result;
	result = online_accounts_web_dialog_on_load_uri_failed ((OnlineAccountsWebDialog*) self, load_event, failing_uri, _error_);
#line 70 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	return result;
#line 316 "WebDialog.c"
}


static gboolean online_accounts_web_dialog_real_set_parameters (OnlineAccountsDialog* base, GHashTable* params) {
	OnlineAccountsWebDialog * self;
	gboolean result = FALSE;
	GHashTable* _tmp0_;
	gboolean _tmp1_;
	WebKitWebView* _tmp2_;
	WebKitWebView* _tmp3_;
	GHashTable* _tmp4_;
	gboolean _tmp5_;
	WebKitWebView* _tmp6_;
	const gchar* _tmp7_;
#line 64 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	self = (OnlineAccountsWebDialog*) base;
#line 64 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_return_val_if_fail (params != NULL, FALSE);
#line 65 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp0_ = params;
#line 65 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp1_ = ONLINE_ACCOUNTS_DIALOG_CLASS (online_accounts_web_dialog_parent_class)->set_parameters (G_TYPE_CHECK_INSTANCE_CAST (self, ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog), _tmp0_);
#line 65 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	if (_tmp1_ == FALSE) {
#line 66 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		result = FALSE;
#line 66 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		return result;
#line 345 "WebDialog.c"
	}
#line 69 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp2_ = self->priv->webview;
#line 69 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_signal_connect_object (_tmp2_, "load-changed", (GCallback) _online_accounts_web_dialog_on_webview_load_webkit_web_view_load_changed, self, 0);
#line 70 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp3_ = self->priv->webview;
#line 70 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_signal_connect_object (_tmp3_, "load-failed", (GCallback) _online_accounts_web_dialog_on_load_uri_failed_webkit_web_view_load_failed, self, 0);
#line 72 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp4_ = params;
#line 72 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp5_ = online_accounts_web_dialog_validate_params (self, _tmp4_);
#line 72 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	if (_tmp5_ == FALSE) {
#line 73 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		result = FALSE;
#line 73 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		return result;
#line 365 "WebDialog.c"
	}
#line 76 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp6_ = self->priv->webview;
#line 76 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp7_ = self->priv->oauth_open_url;
#line 76 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	webkit_web_view_load_uri (_tmp6_, _tmp7_);
#line 77 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	result = TRUE;
#line 77 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	return result;
#line 377 "WebDialog.c"
}


static gboolean online_accounts_web_dialog_is_valid_url (OnlineAccountsWebDialog* self, const gchar* uri) {
	gboolean result = FALSE;
	gchar* scheme;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
#line 80 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 80 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 81 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp0_ = uri;
#line 81 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp1_ = g_uri_parse_scheme (_tmp0_);
#line 81 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	scheme = _tmp1_;
#line 82 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp2_ = scheme;
#line 82 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	if (_tmp2_ == NULL) {
#line 83 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		result = FALSE;
#line 83 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_g_free0 (scheme);
#line 83 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		return result;
#line 409 "WebDialog.c"
	}
#line 85 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp3_ = scheme;
#line 85 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp4_ = g_str_has_prefix (_tmp3_, "http");
#line 85 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	result = _tmp4_;
#line 85 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_free0 (scheme);
#line 85 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	return result;
#line 421 "WebDialog.c"
}


static gboolean online_accounts_web_dialog_validate_params (OnlineAccountsWebDialog* self, GHashTable* params) {
	gboolean result = FALSE;
	GVariant* open_url_var;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GVariant* _tmp2_;
	GVariant* final_url_var;
	GHashTable* _tmp6_;
	gconstpointer _tmp7_;
	GVariant* _tmp8_;
	gboolean _tmp12_ = FALSE;
	const gchar* _tmp13_;
	gboolean _tmp15_ = FALSE;
	const gchar* _tmp16_;
	gboolean _tmp17_;
#line 88 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_return_val_if_fail (params != NULL, FALSE);
#line 89 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp0_ = params;
#line 89 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, ONLINE_ACCOUNTS_KEY_OPEN_URL);
#line 89 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	open_url_var = (GVariant*) _tmp1_;
#line 90 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp2_ = open_url_var;
#line 90 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	if (_tmp2_ != NULL) {
#line 454 "WebDialog.c"
		GVariant* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 91 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp3_ = open_url_var;
#line 91 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp4_ = g_variant_get_string (_tmp3_, NULL);
#line 91 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 91 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_g_free0 (self->priv->oauth_open_url);
#line 91 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		self->priv->oauth_open_url = _tmp5_;
#line 468 "WebDialog.c"
	}
#line 94 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp6_ = params;
#line 94 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp7_ = g_hash_table_lookup (_tmp6_, ONLINE_ACCOUNTS_KEY_FINAL_URL);
#line 94 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	final_url_var = (GVariant*) _tmp7_;
#line 95 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp8_ = final_url_var;
#line 95 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	if (_tmp8_ != NULL) {
#line 480 "WebDialog.c"
		GVariant* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 96 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp9_ = final_url_var;
#line 96 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp10_ = g_variant_get_string (_tmp9_, NULL);
#line 96 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 96 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_g_free0 (self->priv->oauth_final_url);
#line 96 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		self->priv->oauth_final_url = _tmp11_;
#line 494 "WebDialog.c"
	}
#line 99 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp13_ = self->priv->oauth_open_url;
#line 99 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	if (_tmp13_ == NULL) {
#line 99 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp12_ = TRUE;
#line 502 "WebDialog.c"
	} else {
		const gchar* _tmp14_;
#line 99 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp14_ = self->priv->oauth_final_url;
#line 99 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp12_ = _tmp14_ == NULL;
#line 509 "WebDialog.c"
	}
#line 99 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	if (_tmp12_) {
#line 100 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		g_warning ("WebDialog.vala:100: Missing open_url or final_url");
#line 101 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		result = FALSE;
#line 101 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		return result;
#line 519 "WebDialog.c"
	}
#line 104 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp16_ = self->priv->oauth_open_url;
#line 104 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp17_ = online_accounts_web_dialog_is_valid_url (self, _tmp16_);
#line 104 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	if (_tmp17_ == FALSE) {
#line 104 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp15_ = TRUE;
#line 529 "WebDialog.c"
	} else {
		const gchar* _tmp18_;
		gboolean _tmp19_;
#line 104 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp18_ = self->priv->oauth_final_url;
#line 104 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp19_ = online_accounts_web_dialog_is_valid_url (self, _tmp18_);
#line 104 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp15_ = _tmp19_ == FALSE;
#line 539 "WebDialog.c"
	}
#line 104 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	if (_tmp15_) {
#line 105 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		g_warning ("WebDialog.vala:105: Invalid open_url or final_url");
#line 106 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		result = FALSE;
#line 106 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		return result;
#line 549 "WebDialog.c"
	}
#line 109 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	result = TRUE;
#line 109 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	return result;
#line 555 "WebDialog.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 113 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	return self ? g_error_copy (self) : NULL;
#line 562 "WebDialog.c"
}


static gboolean online_accounts_web_dialog_on_load_uri_failed (OnlineAccountsWebDialog* self, WebKitLoadEvent load_event, const gchar* failing_uri, void* _error) {
	gboolean result = FALSE;
	GError* _error_;
	void* _tmp0_;
	GError* _tmp1_;
	const gchar* _tmp2_;
	GError* _tmp3_;
	const gchar* _tmp4_;
	GCompareFunc _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
#line 112 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 112 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_return_val_if_fail (failing_uri != NULL, FALSE);
#line 113 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp0_ = _error;
#line 113 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp1_ = _g_error_copy0 ((GError*) _tmp0_);
#line 113 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_error_ = _tmp1_;
#line 114 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp2_ = failing_uri;
#line 114 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp3_ = _error_;
#line 114 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp4_ = _tmp3_->message;
#line 114 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_warning ("WebDialog.vala:114: Loading uri '%s' failed, error : %s", _tmp2_, _tmp4_);
#line 115 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp5_ = g_strcmp0;
#line 115 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp6_ = failing_uri;
#line 115 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp7_ = self->priv->oauth_open_url;
#line 115 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp8_ = _tmp5_ (_tmp6_, _tmp7_);
#line 115 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	if (_tmp8_ == 0) {
#line 116 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		((OnlineAccountsDialog*) self)->error_code = SIGNONUI_ERROR_NOT_AVAILABLE;
#line 608 "WebDialog.c"
	}
#line 119 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	result = TRUE;
#line 119 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_error_free0 (_error_);
#line 119 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	return result;
#line 616 "WebDialog.c"
}


static void online_accounts_web_dialog_on_webview_load (OnlineAccountsWebDialog* self, WebKitLoadEvent load_event) {
	gchar* redirect_uri;
	WebKitWebView* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	WebKitWebView* _tmp16_;
	guint _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	const gchar* _tmp20_;
#line 122 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_return_if_fail (self != NULL);
#line 123 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp0_ = self->priv->webview;
#line 123 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp1_ = webkit_web_view_get_uri (_tmp0_);
#line 123 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 123 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	redirect_uri = _tmp2_;
#line 124 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp4_ = redirect_uri;
#line 124 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	if (_tmp4_ == NULL) {
#line 124 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp3_ = TRUE;
#line 648 "WebDialog.c"
	} else {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gboolean _tmp7_;
#line 124 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp5_ = redirect_uri;
#line 124 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp6_ = self->priv->oauth_final_url;
#line 124 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp7_ = g_str_has_prefix (_tmp5_, _tmp6_);
#line 124 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp3_ = !_tmp7_;
#line 661 "WebDialog.c"
	}
#line 124 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	if (_tmp3_) {
#line 665 "WebDialog.c"
		WebKitLoadEvent _tmp8_;
		WebKitLoadEvent _tmp12_;
#line 125 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp8_ = load_event;
#line 125 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		if (_tmp8_ == WEBKIT_LOAD_FINISHED) {
#line 672 "WebDialog.c"
			GtkLabel* _tmp9_;
			GtkSpinner* _tmp10_;
			GtkSpinner* _tmp11_;
#line 126 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			_tmp9_ = self->priv->info_label;
#line 126 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			gtk_label_set_label (_tmp9_, _ ("Please enter your credentials…"));
#line 127 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			_tmp10_ = self->priv->spinner;
#line 127 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			gtk_spinner_stop (_tmp10_);
#line 128 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			_tmp11_ = self->priv->spinner;
#line 128 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			gtk_widget_hide ((GtkWidget*) _tmp11_);
#line 129 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			_g_free0 (redirect_uri);
#line 129 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			return;
#line 692 "WebDialog.c"
		}
#line 132 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_tmp12_ = load_event;
#line 132 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		if (_tmp12_ == WEBKIT_LOAD_STARTED) {
#line 698 "WebDialog.c"
			GtkLabel* _tmp13_;
			GtkSpinner* _tmp14_;
			GtkSpinner* _tmp15_;
#line 133 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			_tmp13_ = self->priv->info_label;
#line 133 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			gtk_label_set_label (_tmp13_, _ ("Loading…"));
#line 134 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			_tmp14_ = self->priv->spinner;
#line 134 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			gtk_spinner_start (_tmp14_);
#line 135 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			_tmp15_ = self->priv->spinner;
#line 135 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			gtk_widget_show ((GtkWidget*) _tmp15_);
#line 136 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			_g_free0 (redirect_uri);
#line 136 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
			return;
#line 718 "WebDialog.c"
		}
#line 139 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		_g_free0 (redirect_uri);
#line 139 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
		return;
#line 724 "WebDialog.c"
	}
#line 143 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp16_ = self->priv->webview;
#line 143 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_signal_parse_name ("load-changed", webkit_web_view_get_type (), &_tmp17_, NULL, FALSE);
#line 143 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _online_accounts_web_dialog_on_webview_load_webkit_web_view_load_changed, self);
#line 144 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp18_ = redirect_uri;
#line 144 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 144 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_free0 (self->priv->oauth_response);
#line 144 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	self->priv->oauth_response = _tmp19_;
#line 145 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp20_ = self->priv->oauth_response;
#line 145 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_debug ("WebDialog.vala:145: Found OAUTH Response : %s", _tmp20_);
#line 146 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	((OnlineAccountsDialog*) self)->error_code = SIGNONUI_ERROR_NONE;
#line 147 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_signal_emit_by_name ((OnlineAccountsDialog*) self, "finished");
#line 122 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_free0 (redirect_uri);
#line 750 "WebDialog.c"
}


static GHashTable* online_accounts_web_dialog_real_get_reply (OnlineAccountsDialog* base) {
	OnlineAccountsWebDialog * self;
	GHashTable* result = NULL;
	GHashTable* table;
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GVariant* _tmp3_;
#line 150 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	self = (OnlineAccountsWebDialog*) base;
#line 151 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp0_ = ONLINE_ACCOUNTS_DIALOG_CLASS (online_accounts_web_dialog_parent_class)->get_reply (G_TYPE_CHECK_INSTANCE_CAST (self, ONLINE_ACCOUNTS_TYPE_DIALOG, OnlineAccountsDialog));
#line 151 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	table = _tmp0_;
#line 152 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp1_ = g_strdup (ONLINE_ACCOUNTS_KEY_URL_RESPONSE);
#line 152 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp2_ = self->priv->oauth_response;
#line 152 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_tmp3_ = g_variant_new_string (_tmp2_);
#line 152 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_variant_ref_sink (_tmp3_);
#line 152 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_hash_table_insert (table, _tmp1_, _tmp3_);
#line 153 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	result = table;
#line 153 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	return result;
#line 782 "WebDialog.c"
}


static gboolean online_accounts_web_dialog_real_refresh_captcha (OnlineAccountsDialog* base, const gchar* uri) {
	OnlineAccountsWebDialog * self;
	gboolean result = FALSE;
#line 156 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	self = (OnlineAccountsWebDialog*) base;
#line 156 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 157 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	result = TRUE;
#line 157 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	return result;
#line 797 "WebDialog.c"
}


static void online_accounts_web_dialog_class_init (OnlineAccountsWebDialogClass * klass) {
#line 23 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	online_accounts_web_dialog_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	g_type_class_add_private (klass, sizeof (OnlineAccountsWebDialogPrivate));
#line 23 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	((OnlineAccountsDialogClass *) klass)->set_parameters = (gboolean (*) (OnlineAccountsDialog *, GHashTable*)) online_accounts_web_dialog_real_set_parameters;
#line 23 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	((OnlineAccountsDialogClass *) klass)->get_reply = (GHashTable* (*) (OnlineAccountsDialog *)) online_accounts_web_dialog_real_get_reply;
#line 23 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	((OnlineAccountsDialogClass *) klass)->refresh_captcha = (gboolean (*) (OnlineAccountsDialog *, const gchar*)) online_accounts_web_dialog_real_refresh_captcha;
#line 23 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = online_accounts_web_dialog_finalize;
#line 814 "WebDialog.c"
}


static void online_accounts_web_dialog_instance_init (OnlineAccountsWebDialog * self) {
#line 23 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	self->priv = ONLINE_ACCOUNTS_WEB_DIALOG_GET_PRIVATE (self);
#line 821 "WebDialog.c"
}


static void online_accounts_web_dialog_finalize (GObject * obj) {
	OnlineAccountsWebDialog * self;
#line 23 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ONLINE_ACCOUNTS_TYPE_WEB_DIALOG, OnlineAccountsWebDialog);
#line 24 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_object_unref0 (self->priv->webview);
#line 25 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_free0 (self->priv->oauth_open_url);
#line 26 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_free0 (self->priv->oauth_final_url);
#line 27 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_free0 (self->priv->oauth_response);
#line 28 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_object_unref0 (self->priv->info_label);
#line 29 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	_g_object_unref0 (self->priv->spinner);
#line 23 "/builddir/build/BUILD/switchboard-plug-onlineaccounts-5a0270aa7b580304452bf95a30d7fd634a8cdd9b/src/Authentification/WebDialog.vala"
	G_OBJECT_CLASS (online_accounts_web_dialog_parent_class)->finalize (obj);
#line 843 "WebDialog.c"
}


GType online_accounts_web_dialog_get_type (void) {
	static volatile gsize online_accounts_web_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&online_accounts_web_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (OnlineAccountsWebDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) online_accounts_web_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OnlineAccountsWebDialog), 0, (GInstanceInitFunc) online_accounts_web_dialog_instance_init, NULL };
		GType online_accounts_web_dialog_type_id;
		online_accounts_web_dialog_type_id = g_type_register_static (ONLINE_ACCOUNTS_TYPE_DIALOG, "OnlineAccountsWebDialog", &g_define_type_info, 0);
		g_once_init_leave (&online_accounts_web_dialog_type_id__volatile, online_accounts_web_dialog_type_id);
	}
	return online_accounts_web_dialog_type_id__volatile;
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



